SystemOrganization addCategory: #'GBT-DSL_BuddyWallet'!

Object subclass: #BuddyWallet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_BuddyWallet'!

!BuddyWallet class methodsFor: 'example' stamp: 'hk 5/5/2017 19:13'!
exampleClear
	GbtBizAppServer clear
! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 6/6/2017 16:36'!
exampleData
	GbtBizAppServer clearStore. 
	self new 
		ensureCompilation;
		storeAccounts  ! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 6/6/2017 16:27'!
exampleRun
	(self new
		ensureCompilation;
		buddyWallet) open ! !

!BuddyWallet class methodsFor: 'example' stamp: 'hk 6/6/2017 16:28'!
exampleRunLogin
	(self new 
		ensureCompilation; 
		installUsers;
		login) open
! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 6/6/2017 16:32'!
account
	"self new account"
	^GbtSmartThing copy: 'Account'! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:04'!
account01
	"self new account01 edit"
	^self account
		bizId: self nextBizID;
		nick: #firstAccount;
		IBAN: 'DE51 1234 5678 9876 5432' ;	
		amount: 1000;
		firstName: #Lisa ;
		lastName: #Schmitz;
		eMail: 'Lisa.Schmitz@web.de';
		yourself.

! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:05'!
account02
	"self new account02 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 9876 1234' ;	
		amount: 500;
		firstName: #Tom ;
		lastName: #Taylor;
		eMail: 'Tom.Taylor@gmx.net';
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:05'!
account03
	"self new account03 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0054 1234' ;	
		amount: 1000;
		firstName: #Helmut ;
		lastName: #Lange;
		eMail: 'Helmut@Lange.de';
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:04'!
account04
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 0045 9876';
		nick: #otherAccount;
		amount: -500;
		firstName: #Lisa;
		lastName: #Schmitz;
		eMail: 'Lisa.Schmitz@web.de';
		yourself! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 4/24/2017 16:05'!
account05
	"self new account05 edit"
	^self account
		bizId: self nextBizID;
		IBAN: 'DE51 1005 0500 9999 7777' ;	
		amount: 800;
		firstName: #Helmut ;
		lastName: #Schmidt;
		eMail: 'Helmut@Schmidt.de';
		yourself! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 6/8/2017 16:51'!
buddyWallet  
	^GbtActiveContext definedAs: 'BuddyWallet' ! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 6/8/2017 19:11'!
contexts
	^ '	plain BuddyWalletLogin {
		subcontexts 	: 	BuddyWallet 
		uiSpec 		: 	GbtLoginUI 
		icon 			: 	walletBig
		displayAs 	: 	BuddyWallet
		legalText 	: 	''GloConn International © 2016''
		}
	plain BuddyWallet {
		subcontexts 	: 	MyAccounts Buddies Transfers 
		uiSpec 		: 	GbtMainUI 
		icon 			: 	walletBig
		windowSize 	: 	800 @ 600
		}
	plain MyAccountContext { 
	 	displayAs 	: 	MyAccount
		uiSpec 		: 	GbtItemUI
		icon 			: 	contacts
		}
	plain TransferContext {  
	 	displayAs 	: 	TransferOrder
		uiSpec 		: 	GbtItemUI
		icon 			: 	wallet
		txThings 		: 	transferSource transferSink
		poolThings 	: 	TransferRules
		menu 			: 	doit
		}
	primeList MyAccounts of Account {  
	 	displayAs 	: 	MyAccounts
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	contacts
		loadPolicy 	: 	autoload 
		listColumns 	: 	(nick nickName) amount IBAN 
		listPrefix 	: 	Acc 
		subcontext 	: 	MyAccountContext 
		}
	primeList Transfers of TransferOrder {  
	 	displayAs 	: 	Transfers
		uiSpec 		: 	GbtListAndItemUI
		icon 			: 	wallet
		loadPolicy 	: 	autoload 
		listColumns 	: 	(senderName von) (transferAmount amount) currency (source von) (target an) 
		listPrefix 	: 	MTF 
		subcontext 	: 	TransferContext 
		}
	primeList Buddies of Account {  
	 	displayAs 	: 	Buddies
		uiSpec 		: 	GbtListUI
		icon 			: 	crm
		loadPolicy 	: 	autoload 
		listColumns 	: 	firstName eMail 
		}
	'! !

!BuddyWallet methodsFor: 'functions' stamp: 'hk 5/10/2017 14:08'!
decls
	^'
	declarative SourceDecl  
		(tag oldSourceAmount : amount 
		dispo 
		transferLimit  )
	
	declarative SinkDecl 
		(tag oldSinkAmount : amount )
		
	declarative Transfer  ( 
		oldSourceAmount  oldSinkAmount  dispo  transferLimit  transferAmount
		newSourceAmount newSinkAmount limitConstraint dispoConstraint 
		)
	'
! !

!BuddyWallet methodsFor: 'functions' stamp: 'hk 4/27/2017 17:53'!
doitBehavior: behName  
	^GbtBehavior newStruct: behName arguments: #() define: #(
		READSLOT #(source vSourceNick)							"get the source nickname - as edited by user"
		READSLOT #(target vTargetEmail)						"get the target email - as edited by user"
		ASKROLE #(MyAccounts vSourceNick transferSource) 	"get  accounts for source - do not copy"
		ASKROLE #(Buddies vTargetEmail transferSink) 		"and target into the roles - do not copy"
		TRANSFORM #(transferSource SourceDecl sourceVar)	"get a.o. the source amount"
		TRANSFORM #(transferSink SinkDecl sinkVar)			"and the sink amount"
		COMPOSE #(Transfer sourceVar	sinkVar)				"make the core tx thing with the pool thing,too"						
		CHECK #transferCheck 										"check contraints"
		READSLOT #(newSourceAmount newSourceA) 				"read the final"
		READSLOT #(newSinkAmount newSinkA) 					"account values"
		WRITESLOT #(newSourceA transferSource amount) 		"write them"
		WRITESLOT #(newSinkA transferSink amount) 			"into the accounts"
		SAVECONTEXT #(transferSource Buddies)				"shall be saved in MyAccounts AND Buddies"
		SAVECONTEXT #(transferSink MyAccounts)				"shall be saved in MyAccounts AND Buddies"
		COMMIT #void 												"commit the tx"
		ASSIGNTODAY #(contextVO date)
	)! !

!BuddyWallet methodsFor: 'compile' stamp: 'hk 6/8/2017 19:05'!
ensureCompilation
	"sort of incremental ..."
	GbtBizAppServer default hasThings ifFalse: 
		[GbtCompiler new parse: self things onError: [ :msg :pos | self error: msg, ' at: ', pos printString ]].
	GbtBizAppServer default hasDecls ifFalse: 
		[GbtCompiler new parse: self decls onError: [ :msg :pos | self error: msg, ' at: ', pos printString ]].
	GbtBizAppServer default hasContexts ifFalse: 
		[GbtCompiler new parse: self contexts onError: [ :msg :pos | self error: msg, ' at: ', pos printString].
		"not yet in parser"
		((GbtBizAppServer default contextNamed: #TransferContext) ifNil: [^self])
			chooseFor: #source use: #nick from: (GbtBizAppServer default contextNamed: #MyAccounts);
			chooseFor: #target use: #eMail from: (GbtBizAppServer default contextNamed: #Buddies);
			behavior: (self doitBehavior: #doit);
			createBehaviors: #(userName);
			behavior: #userName actions: #(ASSIGNUSER senderName)].! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 6/6/2017 16:32'!
installUsers
	#(Tom Lisa) do: [:u| GbtBizAppServer default addUser: u withRole: 
			(GbtRole forExecute 
				addFilter: '#firstName = ''',u asString, '''' for: #MyAccounts;
				addFilter: '#senderName = ''',u asString, '''' for: #Transfers) ].
	#(Tony Robert) do: [:u| GbtBizAppServer default addUser: u withRole: (GbtRole forWrite )].
	#(Bob) do: [:u| GbtBizAppServer default addUser: u withRole: (GbtRole forRead )]
! !

!BuddyWallet methodsFor: 'contexts' stamp: 'hk 6/8/2017 16:51'!
login
	^GbtActiveContext definedAs:  'BuddyWalletLogin'! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 3/20/2017 18:05'!
nextBizID
	^GbtBizAppServer default nextIdOfContextNoPolicy: #MyAccounts! !

!BuddyWallet methodsFor: 'test data' stamp: 'hk 5/13/2017 18:08'!
storeAccounts
	"creates the noPolicy for the test data"
	GbtBizAppServer default contextNoPolicyOf: #MyAccounts prefix: #Acc	.
	self account01 storeSubtree.
	self account02 storeSubtree.
	self account03 storeSubtree. 
	self account04 storeSubtree.
	self account05 storeSubtree! !

!BuddyWallet methodsFor: 'things' stamp: 'hk 6/8/2017 19:08'!
things
^'	thing Contact { 
		*val firstName 		:  
		*val lastName  		:  
		*val eMail     		:   					
		val phone     		:   
		}
	thing Account 
		summary 				:  ''#firstName #nick'' 
		{ 
		*val nick 			:  soleAccount 
		*val IBAN 			:   
		*no amount 			:  0 
		*val currency 		:  EUR
		*no dispo 			:  0 
		*no transferLimit 	:  1000 
		*thing person 		:  Contact
		}
	thing TransferOrder
		summary 				:  ''transfer order template''
		{ 
		*val senderName  	:  
		*no transferAmount :  0 
		*val currency 		:  EUR 
		val source 			: 
		val target 			: 
		val date 				: 
		}				
	thing TransferRules {  
		*calc newSourceAmount 			:  ''#oldSourceAmount - #transferAmount''
		*calc newSinkAmount 				:  ''#oldSinkAmount + #transferAmount''
		*constraint limitConstraint 	:  ''#transferAmount asNumber < #transferLimit asNumber''  ''limit exceeded''
		*constraint dispoConstraint 	:  ''#oldSourceAmount asNumber - #transferAmount asNumber + #dispo asNumber >= 0''  ''no balace cover''
		}
'
! !
